﻿<img src="assets/logo.png" style="width:300px;">

## What is iCal.NET?
iCal.NET is an iCalendar (RFC 5545) class library for .NET aimed at providing RFC 5545 compliance, while providing full compatibility with popular calendaring applications and libraries.

## Mission Statement
Make ICal.NET the best in class for .NET - in terms of usability, performance and reliability (RFC compliance / compatibility).

**Join the project and help to achieve this goal!**

## Getting iCal.Net

### iCal.Net v5 pre-releases 

Starting with 5.0.0-pre.39, iCal.Net v5 pre-releases are available as [NuGet Packages](https://www.nuget.org/packages/Ical.Net)

v5 is an extensive rewrite of the library, with a focus on performance, correctness and usability. All issues reported in prior versions have been addressed, and the library has been thoroughly tested.

Daily pre-releases are available as [GitHub Packages](https://github.com/ical-org/ical.net/pkgs/nuget/Ical.Net)<br/>
and from the [zipped packages folder](https://github.com/ical-org/ical.net/tree/main/v5-daily-builds).

**We strongly recommend using the pre-release packages**. They are stable and contain many bug fixes and improvements over the v4 release.<br/>
See the [API Changes Document](https://github.com/ical-org/ical.net/wiki/API-Changes-v4-to-v5) for more information.

### iCal.Net v4
is still available as [a NuGet Package](https://www.nuget.org/packages/Ical.Net).

## Examples

The wiki contains several pages of examples of common ical.net usage scenarios.

* [Simple event with a recurrence](https://github.com/ical-org/ical.net/wiki)
* [Deserializing an ics file](https://github.com/ical-org/ical.net/wiki/Deserialize-an-ics-file)
* [Working with attachments](https://github.com/ical-org/ical.net/wiki/Working-with-attachments)
* [Working with recurring elements](https://github.com/ical-org/ical.net/wiki/Working-with-recurring-elements)
* [Concurrency scenarios and PLINQ](https://github.com/ical-org/ical.net/wiki/Concurrency-scenarios-and-PLINQ)
* [Migrating from dday.ical](https://github.com/ical-org/ical.net/wiki/Migrating-from-dday.ical)

## Versioning

ical.net uses [semantic versioning](http://semver.org/). In a nutshell:

> Given a version number MAJOR.MINOR.PATCH, increment the:
>
> 1. MAJOR version when you make incompatible API changes,
> 2. MINOR version when you add functionality in a backwards-compatible manner, and
> 3. PATCH version when you make backwards-compatible bug fixes.

## Contributing

* [Submit a bug report or issue](https://github.com/ical-org/ical.net/wiki/Filing-a-(good)-bug-report)
* [Contribute code by submitting a pull request](https://github.com/ical-org/ical.net/wiki/Contributing-a-(good)-pull-request). **Always open an issue first**, so we can discuss necessary changes.
* [Ask a question](https://github.com/ical-org/ical.net/discussions). **Please never use the issue tracker for questions.**

## Support

* We ask and encourage you to contribute back to the project. This is especially true if you are using the library in a commercial product.

* Questions asked in the discussion area are open to the community or experienced users to answer. Give maintainers a helping hand by answering questions whenever you can.

* Remember that keeping ical.net up is something ical.net maintainers and many contributors do in their spare time.

<details closed>
    <summary>
      Paid support
    </summary>

In case you need it, [Rian Stockbower may offer paid support and bugfixes](https://rianjs.net/consulting).
 A few basic rules to consider when asking for this kind of support:

* Any changes made to the ical.net library are open source, and will always be published on nuget for others to consume.
* You do not own the changes made to the library even if you paid for them.
* Congruence with the ical-org vision for the future of ical.net is required. That means we step back from things like "add Exchange interop", or take  dependencies on third-party libraries that benefit only your one or very few use cases.

</details>

## Creative Commons

iCal.Net logo adapted from [Love Calendar](https://thenounproject.com/term/love-calendar/116866/) By Sergey Demushkin, RU
